Attribute VB_Name = "BasCommon"
Option Explicit

'============================ DECLARATIONS ================================

'-- Dclaration utiles !!!
Public Const ERROR_SUCCESS As Long = 0&
Public Const WM_USER As Long = &H400
Private Const MAX_PATH As Long = 260

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                                    (ByVal hwnd As Long, ByVal wMsg As Long, _
                                     ByVal wParam As Long, ByVal lParam As Any) As Long


Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long

Public Const WM_SETREDRAW = &HB

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Const SW_SHOWDEFAULT As Long = 10
Public Const SW_SHOWMAXIMIZED As Long = 3
Public Const SW_SHOWMINIMIZED As Long = 2
Public Const SW_SHOWMINNOACTIVE As Long = 7
Public Const SW_SHOWNOACTIVATE As Long = 4
Public Const SW_SHOWNORMAL As Long = 1

Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'===== Lire, Ecrire, Crer, ... Cls de registre =============================
Public Enum KeyType
REG_NONE = 0        ' Undefined key type
REG_SZ = 1        ' Unicode nul terminated string
    REG_EXPAND_SZ = 2
    REG_BINARY = 3    ' Free form binary
    REG_DWORD = 4
    REG_MULTI_SZ = 7
End Enum

Public Const HKCR As Long = &H80000000    'HKEY_CLASSES_ROOT
Public Const HKCC As Long = &H80000005    'HKEY_CURRENT_CONFIG
Public Const HKCU As Long = &H80000001    'HKEY_CURRENT_USER
Public Const HKLM As Long = &H80000002    'HKEY_LOCAL_MACHINE
Public Const HKUS As Long = &H80000003    'HKEY_USERS

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long


'==== Lire les repertoires spciaux de Windows ============================
Private Declare Function SHGetSpecialFolderPath Lib "shell32.dll" Alias "SHGetSpecialFolderPathA" _
                                                (ByVal hwndOwner As Long, ByVal lpszPath As String, _
                                                 ByVal nFolder As Long, ByVal fCreate As Long) As Long

'==== Lire / Ecrire dans un Fichier .ini ==================================
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
                                                 (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, _
                                                  ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" _
                                                   (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, _
                                                    ByVal lpFileName As String) As Long

'==== Positionner une fenetre =============================================
Public Const SWP_NOMOVE = 2
Public Const SWP_NOSIZE = 1
Public Const SWP_SHOWWINDOW = &H40
Public Const SWP_NOZORDER = &H4
Public Const HWND_BOTTOM = 1
Public Const HWND_TOP = 0
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2

Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal _
                                                                       hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal _
                                                                                                                                                    cy As Long, ByVal wFlags As Long) As Long

'==== Ouvrir une boite de selection d'un rpertoire========================
Private Const BIF_STATUSTEXT As Long = &H4&
Public Const BIF_RETURNONLYFSDIRS As Long = &H1
Public Const BIF_DONTGOBELOWDOMAIN As Long = &H2
Public Const BIF_RETURNFSANCESTORS As Long = &H8
Public Const BIF_BROWSEFORCOMPUTER As Long = &H1000
Public Const BIF_BROWSEFORPRINTER As Long = &H2000
Public Const BIF_BROWSEINCLUDEFILES As Long = &H4000

Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BROWSEINFO) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, _
                                                            ByVal lpBuffer As String) As Long
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, _
                                                                  ByVal lpString2 As String) As Long
Private Const BFFM_INITIALIZED As Long = 1
Private Const BFFM_SELCHANGED As Long = 2
Private Const BFFM_SETSTATUSTEXT As Long = (WM_USER + 100)
Private Const BFFM_SETSELECTION As Long = (WM_USER + 102)

Private Type BROWSEINFO
    hwndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfnCallback As Long
    lParam As Long
    iImage As Long
End Type
Private m_strDirectory As String

'==== Lire les Infos Fichier =============================================
Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Public Enum DTvalue
    DT_CREATED = &H1
    DT_ACCESSED = &H2
    DT_LASTMODIFIED = &H3
End Enum

Private Const GENERIC_WRITE = &H40000000
Private Const OPEN_EXISTING = 3
Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2

Public Const FILE_ATTRIBUTE_ARCHIVE = &H20
Public Const FILE_ATTRIBUTE_DIRECTORY = &H10
Public Const FILE_ATTRIBUTE_HIDDEN = &H2
Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const FILE_ATTRIBUTE_READONLY = &H1
Public Const FILE_ATTRIBUTE_SYSTEM = &H4
Public Const FILE_ATTRIBUTE_TEMPORARY = &H100

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function GetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long
Private Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As FILETIME, lpLocalFileTime As FILETIME) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long

Private Declare Function GetVersion Lib "kernel32" () As Long
Private Declare Function GetTextExtentPoint32 Lib "gdi32" Alias _
                                              "GetTextExtentPoint32A" (ByVal hdc As Long, ByVal lpsz As String, _
                                                                       ByVal cbString As Long, lpSize As POINTAPI) As Long

'==== Regler la transparence d'affichage d'une Form ====================
Private Declare Function SetLayeredWindowAttributes Lib "user32.dll" ( _
                                                    ByVal hwnd As Long, _
                                                    ByVal crKey As Long, _
                                                    ByVal bAlpha As Byte, _
                                                    ByVal dwFlags As Long) As Long

Private Const WS_EX_LAYERED As Long = &H80000
Private Const LWA_ALPHA As Long = &H2
Private Const GWL_EXSTYLE As Long = -20

Private Type VS_FIXEDFILEINFO
    dwSignature As Long
    dwStrucVersionl As Integer    '  e.g. = &h0000 = 0
    dwStrucVersionh As Integer    '  e.g. = &h0042 = .42
    dwFileVersionMSl As Integer    '  e.g. = &h0003 = 3
    dwFileVersionMSh As Integer    '  e.g. = &h0075 = .75
    dwFileVersionLSl As Integer    '  e.g. = &h0000 = 0
    dwFileVersionLSh As Integer    '  e.g. = &h0031 = .31
    dwProductVersionMSl As Integer    '  e.g. = &h0003 = 3
    dwProductVersionMSh As Integer    '  e.g. = &h0010 = .1
    dwProductVersionLSl As Integer    '  e.g. = &h0000 = 0
    dwProductVersionLSh As Integer    '  e.g. = &h0031 = .31
    dwFileFlagsMask As Long    '  = &h3F for version "0.42"
    dwFileFlags As Long    '  e.g. VFF_DEBUG Or VFF_PRERELEASE
    dwFileOS As Long    '  e.g. VOS_DOS_WINDOWS16
    dwFileType As Long    '  e.g. VFT_DRIVER
    dwFileSubtype As Long    '  e.g. VFT2_DRV_KEYBOARD
    dwFileDateMS As Long    '  e.g. 0
    dwFileDateLS As Long    '  e.g. 0
End Type
Private Declare Function GetFileVersionInfo Lib "Version.dll" Alias "GetFileVersionInfoA" (ByVal lptstrFilename As String, ByVal dwhandle As Long, ByVal dwlen As Long, lpData As Any) As Long
Private Declare Function GetFileVersionInfoSize Lib "Version.dll" Alias "GetFileVersionInfoSizeA" (ByVal lptstrFilename As String, lpdwHandle As Long) As Long
Private Declare Function VerQueryValue Lib "Version.dll" Alias "VerQueryValueA" (pBlock As Any, ByVal lpSubBlock As String, lplpBuffer As Any, puLen As Long) As Long
Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, ByVal Source As Long, ByVal length As Long)

'Declaration pour recupere le chemin du repertoire systeme
Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" ( _
                                    ByVal lpBuffer As String, _
                                    ByVal nSize As Long) As Long

'========================= FIN DES DECLARATIONS ===========================


Public Function DimText(ByVal hdc As Long, ByVal Texte As String) As POINTAPI
Dim taille As POINTAPI

    GetTextExtentPoint32 hdc, Texte, Len(Texte), taille
    taille.X = taille.X * Screen.TwipsPerPixelX
    taille.Y = taille.Y * Screen.TwipsPerPixelY
    DimText = taille

End Function

'Cette fonction permet de recupere le chemin du repertoire systeme ("windows\syste32")
'ceci dans le but d'avoir un programme vraiment independant
Public Function GetWinSysDir() As String
Dim strBuffer As String

    strBuffer = Space(MAX_PATH)
    GetSystemDirectory strBuffer, Len(strBuffer)
    GetWinSysDir = Left(strBuffer, InStr(strBuffer, vbNullChar) - 1)
End Function


Public Function GetWinVersion() As String
Dim Ver As Long
    Ver = GetVersion()
    GetWinVersion = (Ver And &HFF&) & "." _
                    & (Ver And &HFF00&) \ 2 ^ 8 _
                    & "." & (Ver And &HFFFF0000) \ 2 ^ 16
End Function

'=======================================================================================
Public Function SelectFolder(Titre As String, Handle As Long, _
                             Optional uFlags As Long = BIF_RETURNONLYFSDIRS, _
                             Optional ByVal StartDir As String) As String

Dim lpIDList As Long
Dim strBuffer As String
Dim strTitre As String
Dim tBrowseInfo As BROWSEINFO

    m_strDirectory = StartDir & vbNullChar

    strTitre = Titre
    With tBrowseInfo
        .hwndOwner = Handle
        .lpszTitle = lstrcat(strTitre, "")
        .ulFlags = uFlags    '+ BIF_DONTGOBELOWDOMAIN
        .lpfnCallback = GetAddressOfFunction(AddressOf BrowseCallbackProc)
    End With

    lpIDList = SHBrowseForFolder(tBrowseInfo)

    If (lpIDList) Then
        strBuffer = String(MAX_PATH, vbNullChar)
        SHGetPathFromIDList lpIDList, strBuffer
        CoTaskMemFree lpIDList
        SelectFolder = Left(strBuffer, InStr(strBuffer, vbNullChar) - 1)
    Else
        SelectFolder = vbNullString
    End If

End Function

Private Function BrowseCallbackProc(ByVal hwnd As Long, ByVal uMessage As Long, ByVal lpIDList As Long, _
                                    ByVal pData As Long) As Long

Dim lngRet As Long
Dim strBuffer As String

    On Error Resume Next
    Select Case uMessage
    Case BFFM_INITIALIZED
        Call SendMessage(hwnd, BFFM_SETSELECTION, 1, m_strDirectory)
    Case BFFM_SELCHANGED
        strBuffer = Space(MAX_PATH)
        lngRet = SHGetPathFromIDList(lpIDList, strBuffer)
        If lngRet = 1 Then
            Call SendMessage(hwnd, BFFM_SETSTATUSTEXT, 0, strBuffer)
        End If
    End Select
    BrowseCallbackProc = 0
End Function

Public Function GetAddressOfFunction(P As Long) As Long
    GetAddressOfFunction = P
End Function
'=======================================================================================

Public Function WriteIniFile(Section As String, Cle As String, ByVal Valeur As String, Fichier As String) As Long
    WriteIniFile = WritePrivateProfileString(Section, Cle, Valeur, Fichier)
    'Exemple d'ecriture
    'WriteIniFile "Affichage", "State", "Maximized", "c:\config.ini"
    'WriteIniFile "Affichage", "Left", "50", "c:\config.ini"
    'WriteIniFile "Affichage", "Top", "80", "c:\config.ini"
End Function

Public Function ReadIniFile(Section As String, Cle As String, Fichier As String, _
                            Optional ByVal ValeurParDefaut As String = "") As String
Dim strReturn As String
    strReturn = String(255, 0)
    GetPrivateProfileString Section, Cle, ValeurParDefaut, strReturn, Len(strReturn), Fichier
    ReadIniFile = Left(strReturn, InStr(strReturn, Chr(0)) - 1)

    'Exemple de lecture
    'LeftParam = ReadIniFileFile("Affichage", "Left", "c:\config.ini", 100)
End Function

'======================  Lire les rpertoires spciaux de Windows ====================
Public Function GetSpecialFolderPath(ByVal dossier As Long, hwnd As Long)
'0 : C:\Documents and Settings\Administrateur\Bureau
'2 : C:\Documents and Settings\Administrateur\Menu Dmarrer\Programmes
'5 : C:\Documents and Settings\Administrateur\Mes documents
'6 : C:\Documents and Settings\Administrateur\Favoris
'7 : C:\Documents and Settings\Administrateur\Menu Dmarrer\Programmes\Dmarrage
'8 : C:\Documents and Settings\Administrateur\Recent
'9 : C:\Documents and Settings\Administrateur\SendTo
'11 : C:\Documents and Settings\Administrateur\Menu Dmarrer
'16 : C:\Documents and Settings\Administrateur\Bureau
'19 : C:\Documents and Settings\Administrateur\Voisinage rseau
'20 : C:\WINNT\Fonts
'21 : C:\Documents and Settings\Administrateur\Modles
'22 : C:\Documents and Settings\All Users\Menu Dmarrer
'23 : C:\Documents and Settings\All Users\Menu Dmarrer\Programmes
'24 : C:\Documents and Settings\All Users\Menu Dmarrer\Programmes\Dmarrage
'25 : C:\Documents and Settings\All Users\Bureau
'26 : C:\Documents and Settings\Administrateur\Application Data
'27 : C:\Documents and Settings\Administrateur\Voisinage d'impression
'28 : C:\Documents and Settings\Administrateur\Local Settings\Application Data
'31 : C:\Documents and Settings\All Users\Favoris
'32 : C:\Documents and Settings\Administrateur\Local Settings\Temporary Internet Files
'33 : C:\Documents and Settings\Administrateur\Cookies
'34 : C:\Documents and Settings\Administrateur\Local Settings\Historique
'35 : C:\Documents and Settings\All Users\Application Data
'36 : C:\WINNT
'37 : C:\WINNT\System32
'38 : C:\Program Files
'39 : C:\Documents and Settings\Administrateur\Mes documents\Mes images
'40 : C:\Documents and Settings\Administrateur
'41 : C:\WINNT\System32
'43 : C:\Program Files\Fichiers communs
'45 : C:\Documents and Settings\All Users\Modles
'46 : C:\Documents and Settings\All Users\Documents
'47 : C:\Documents and Settings\All Users\Menu dmarrer\Programmes\Outils d'administration
Dim buffer As String

    buffer = Space(256)
    SHGetSpecialFolderPath hwnd, buffer, dossier, 0
    GetSpecialFolderPath = Left(buffer, InStr(buffer, Chr(0)) - 1)

End Function

'==== Renvoie la Date et l'heure d'un fichier ============================
Public Function GetFTime(ByVal File As String, DTDate As DTvalue, Optional BetweenDT As String = "") As Date

'-----  Version avec API Windows ------------
'    Dim lngHandle As Long
'    Dim FT1 As FILETIME, FT2 As FILETIME, FT3 As FILETIME, FT4 As FILETIME
'    Dim SysTime As SYSTEMTIME
'
'    lngHandle = CreateFile(File, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)
'    Call GetFileTime(lngHandle, FT1, FT2, FT3)
'    Select Case DTDate
'    Case DT_CREATED
'        FileTimeToLocalFileTime FT1, FT4
'    Case DT_ACCESSED
'        FileTimeToLocalFileTime FT2, FT4
'    Case DT_LASTMODIFIED
'        FileTimeToLocalFileTime FT3, FT4
'    Case Else
'        Exit Function
'    End Select
'    FileTimeToSystemTime FT4, SysTime
'    CloseHandle lngHandle
'    GetFTime = Format(Str$(SysTime.wDay), "00") _
     '            & "/" & Format(Trim(Str$(SysTime.wMonth)), "00") _
     '            & "/" + Trim(Str$(SysTime.wYear)) _
     '            & " " & Trim(BetweenDT) _
     '            & " " & Format(Str$(SysTime.wHour), "00") _
     '            & ":" & Format(Str$(SysTime.wMinute), "00") _
     '            & ":" & Format(Str$(SysTime.wSecond), "00")

'----- Version avec File System Object --------
Dim FSO As FileSystemObject, f As File

    Set FSO = New FileSystemObject

    On Error GoTo Fin
    Set f = FSO.GetFile(File)
    Select Case DTDate
    Case DT_CREATED
        GetFTime = f.DateCreated
    Case DT_ACCESSED
        GetFTime = f.DateLastAccessed
    Case DT_LASTMODIFIED
        GetFTime = f.DateLastModified
    End Select
    Set f = Nothing
Fin:
    Set FSO = Nothing

End Function

Public Function GetFSize(ByVal File As String) As Long
Dim lngHandle As Long, lngLong As Long
    lngHandle = CreateFile(File, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)
    'Get the file's size
    GetFSize = GetFileSize(lngHandle, lngLong)
    CloseHandle lngHandle
End Function

Public Sub SetBackColor(frm As Form)
Dim Ctrl As Control
    For Each Ctrl In frm.Controls
        If TypeOf Ctrl Is Label Or TypeOf Ctrl Is Frame _
           Or TypeOf Ctrl Is CheckBox Or TypeOf Ctrl Is OptionButton _
           Or TypeOf Ctrl Is PictureBox Then
            Ctrl.BackColor = frm.BackColor
        End If
    Next
End Sub

Public Function ExistProperty(Obj As Object, ByVal PropertyName As String) As Boolean
    On Error Resume Next
    CallByName Obj, PropertyName, VbGet
    ExistProperty = (Err.Number = 0)
    Err.Clear
End Function

Public Sub SetFormTransp(ByVal hwnd As Long, ByVal Value As Integer)
'Regle la transparence d'affichage d'une Form
'Exemple avec transparence = 80% :
'SetFormTransp Me.Hwnd, 80
    SetWindowLong hwnd, GWL_EXSTYLE, WS_EX_LAYERED
    SetLayeredWindowAttributes hwnd, 0, 255 * Value / 100, LWA_ALPHA
End Sub

Public Function KillProcess(ByVal ProcessName As String) As Boolean
Dim svc As Object
Dim sQuery As String
Dim oproc
    Set svc = GetObject("winmgmts:root\cimv2")
    sQuery = "select * from win32_process where name=' & ProcessName & "    '"
    For Each oproc In svc.execquery(sQuery)
        oproc.Terminate
    Next
    Set svc = Nothing
End Function

'====Ajouter un "\" dans un path ==========================================
Public Function AddSlash(ByVal SlashStr As String) As String
    If Right(SlashStr, 1) <> "\" Then SlashStr = SlashStr & "\"
    AddSlash = SlashStr
End Function

Function IsPair(ByVal MyVar As Variant) As Boolean
    IsPair = (MyVar Mod 2 = 0)
End Function

Public Function NoTabs(ByVal strg As String) As String
    While InStr(1, strg, vbTab, vbTextCompare) <> 0
        strg = Replace(strg, vbTab, " ", vbTextCompare)
    Wend
    NoTabs = strg
End Function

Public Function NoBlank(ByVal strg As String) As String
    While InStr(1, strg, " ", vbTextCompare) <> 0
        strg = Replace(strg, " ", "", vbTextCompare)
    Wend
    NoBlank = strg
End Function

Public Function ExistFile(ByVal sFullPath As String) As Boolean
    ExistFile = Dir(sFullPath) <> ""
End Function

Public Function ExtractFilePath(ByVal sFullPath As String, Optional ByVal EndSlash As Boolean = True) As String
    If Right(sFullPath, 1) = "\" Then
        ExtractFilePath = sFullPath
    Else
        ExtractFilePath = Left(sFullPath, InStrRev(sFullPath, "\"))
    End If
    If Not EndSlash Then ExtractFilePath = Left(ExtractFilePath, Len(ExtractFilePath) - 1)
End Function

Public Function ExtractFileName(ByVal sFullPath As String) As String
    If InStr(sFullPath, "\") = 0 And Len(sFullPath) > 0 Then
        ExtractFileName = sFullPath
        Exit Function
    End If
    If Right(sFullPath, 1) = "\" Then
        ExtractFileName = ""
        Exit Function
    End If
    ExtractFileName = Mid(sFullPath, InStrRev(sFullPath, "\") + 1)
End Function

Public Function ExtractLastDir(ByVal sFullPath As String) As String
Dim Splitf() As String
    If Right$(sFullPath, 1) = "\" Then sFullPath = Left$(sFullPath, Len(sFullPath) - 1)
    Splitf = Split(sFullPath, "\")
    ExtractLastDir = Splitf(UBound(Splitf))
End Function

Public Function ExtractFileExt(ByVal sFullPath As String) As String
Dim sName As String
    sName = ExtractFileName(sFullPath)
    If InStr(sName, ".") = 0 Then
        ExtractFileExt = ""
    Else
        ExtractFileExt = Mid(sName, InStrRev(sName, ".") + 1)
    End If
End Function

'=========== Acces au Registre =========================================
Function RegQueryStringValue(ByVal hKey As Long, ByVal strValueName As String, lValueType As KeyType) As String
Dim lResult As Long, strBuf As String, lDataBufSize As Long
    'retrieve nformation about the key
    lResult = RegQueryValueEx(hKey, strValueName, 0, lValueType, ByVal 0, lDataBufSize)
    If lResult = ERROR_SUCCESS Then
        If lValueType = REG_SZ Then
            'Create a buffer
            strBuf = String(lDataBufSize, Chr$(0))
            'retrieve the key's content
            lResult = RegQueryValueEx(hKey, strValueName, 0, 0, ByVal strBuf, lDataBufSize)
            If lResult = 0 Then
                'Remove the unnecessary chr$(0)'s
                RegQueryStringValue = Left$(strBuf, InStr(1, strBuf, Chr$(0)) - 1)
            End If
        ElseIf lValueType = REG_BINARY Then
            Dim strData As Integer
            'retrieve the key's value
            lResult = RegQueryValueEx(hKey, strValueName, 0, 0, strData, lDataBufSize)
            If lResult = 0 Then
                RegQueryStringValue = strData
            End If
        End If
    End If
End Function

Function GetRegValue(hKey As Long, keyPath As String, key As String, kType As KeyType)
Dim Ret
    'Open the key
    RegOpenKey hKey, keyPath, Ret
    'Get the key's content
    GetRegValue = RegQueryStringValue(Ret, key, kType)
    'Close the key
    RegCloseKey Ret
End Function

Public Function StrExchange(str1 As String, str2 As String)
Dim str3 As String
    str3 = str1
    str1 = str2
    str2 = str3
End Function

Public Function GetFileVerInfo(sFullPath As String) As String
Dim rc As Long, lDummy As Long, sBuffer() As Byte
Dim lBufferLen As Long, lVerPointer As Long, udtVerBuffer As VS_FIXEDFILEINFO
Dim lVerbufferLen As Long

    '*** Get size ****
    lBufferLen = GetFileVersionInfoSize(sFullPath, lDummy)
    If lBufferLen < 1 Then
        GetFileVerInfo = ""    ' No Version Info available!
        Exit Function
    End If

    '**** Store info to udtVerBuffer struct ****
    ReDim sBuffer(lBufferLen)
    rc = GetFileVersionInfo(sFullPath, 0&, lBufferLen, sBuffer(0))
    rc = VerQueryValue(sBuffer(0), "\", lVerPointer, lVerbufferLen)
    MoveMemory udtVerBuffer, lVerPointer, Len(udtVerBuffer)

    '**** Determine File Version number ****
    GetFileVerInfo = Format$(udtVerBuffer.dwFileVersionMSh) & "." & _
                     Format$(udtVerBuffer.dwFileVersionMSl) & "." & _
                     Format$(udtVerBuffer.dwFileVersionLSh) & "." & _
                     Format$(udtVerBuffer.dwFileVersionLSl)

    '**** Determine Product Version number ****
    'ProdVer = Format$(udtVerBuffer.dwProductVersionMSh) & "." & Format$(udtVerBuffer.dwProductVersionMSl) & "." & Format$(udtVerBuffer.dwProductVersionLSh) & "." & Format$(udtVerBuffer.dwProductVersionLSl)

End Function

