Attribute VB_Name = "Functions"
Option Explicit

Public File As String, AppDir As String
Attribute AppDir.VB_VarUserMemId = 1073741824
Public AllPath As Variant
Attribute AllPath.VB_VarUserMemId = 1073741826
Public Clear As Boolean
Attribute Clear.VB_VarUserMemId = 1073741827
Public NameTab() As String
Attribute NameTab.VB_VarUserMemId = 1073741828

'type pour une reference
Public Type RefType
Nom As String         'Nom de la reference
Chem As String    'Chemin de la reference
Fich As String    'Nom du fichier
Dep As String       'nom du fichier de dependances
End Type


'fonction permettant de recupere les info de la reference
Public Sub ReadREF(ByVal RF As String)
Dim DLL As RefType

    DLL.Chem = RF
    DLL.Chem = Replace(DLL.Chem, "..\", "")
    DLL.Fich = ExtractFileName(DLL.Chem)      ' On recupere le fichier avec extention

    If LCase(Right(DLL.Chem, 3)) = "dll" Then
        DLL.Dep = Mid(DLL.Chem, 1, Len(DLL.Chem) - 3) & "DEP"

        'On recherche aussi les fichiers dont depend cette reference
        If ExistFile(DLL.Dep) Then
            SearchInDEP DLL.Dep, DLL.Fich
        Else
            'si le fichier de dpendances n'existe pas, on ajoute la dll dans la liste
            If Not Exist(DLL.Fich) Then LoadMSF DLL.Fich, DLL.Chem, DLL.Nom
        End If
    Else
        'Si le fichier n'est pas une dll, on l'ajoute  dans la liste
        If Not Exist(DLL.Fich) Then LoadMSF DLL.Fich, DLL.Chem, DLL.Nom
    End If
End Sub
'fonction permettant de recuperer l'ocx
Public Sub ReadOCX(ByVal OCX As String)
Dim DLL As RefType

    DLL.Chem = OCX
    DLL.Fich = ExtractFileName(DLL.Chem)

    'On ajoute l'objet dans la liste des fichiers
    DLL.Dep = Mid(DLL.Chem, 1, Len(DLL.Chem) - 3) & "DEP"

    'On recherche aussi les fichiers dont depend cet objet
    If ExistFile(DLL.Dep) Then
        SearchInDEP DLL.Dep, DLL.Fich
    Else
        'Si le fichier n'est pas une dll ou n'a pas de dependance, on l'ajoute  dans la liste
        If Not Exist(DLL.Fich) Then LoadMSF DLL.Fich, DLL.Chem, DLL.Nom
    End If
End Sub

'Et la procedure la plus importante, celle qui
'cherche les fichiers lies dans les DLL.
Private Function SearchInDEP(File As String, Section As String)
Dim i As Integer
Dim Word As String, Ini As String
Dim Fich As String, Path As String
Dim lang As String, key As String
Dim Register As String

    Register = ReadIniFile(Section, "Register", File)
    If Not Exist(Section) Then LoadMSF Section, ExtractFilePath(File) & Section, Section, Register
    i = 1
    Fich = Mid(Section, 1, Len(Section) - 4)     'On recupere le fichier (sans extention)
    'il nous sera utile dans la suite
    Do
        key = "Uses" + Trim(Str(i))          'On genere des cles
        Word = ReadIniFile(Section, key, File)   'On lit le fichier "file" dans la section "section"
        If Word = "" Then Exit Do
        'avec la cle "key", pour trouver les fichiers de
        'dependance

        'On recupere le chemin du fichier pour pouvoir l'ajouter dans la liste
        Path = Mid(File, 1, Len(File) - Len(Section)) & Word
        Register = ReadIniFile(Word, "Register", File)
        'Et on l'ajoute dans le liste
        If Not Exist(Word) Then LoadMSF Word, Path, Mid(Word, 1, Len(Word) - 4), Register
        i = i + 1

        'Certain fichier ont des fichiers de dependance selon la langue
        'Cette partie permet donc de retrouver ces fichiers en fonction de la langue
        'choisi dans le combobox Langue
        Select Case ShowDep.Langage.ListIndex
        Case 0: lang = " <000C>"     'Code de langue : Francais
        Case 1: lang = " <0010>"     'Code de langue : Italien
        Case 2: lang = " <0007>"     'Code de langue : Allemand
            'Case 3: lang = " <000A>"     'Code de langue : Espagnol
            'Case 3: lang = " <0011>"     'Code de langue : Japonais
            'etc ...
        End Select

        'On recupere le fichier selon la langue
        Ini = ReadIniFile(Section & lang, "Uses1", File)
        'Et son chemin d'acces
        Path = Mid(File, 1, Len(File) - Len(Section)) & Ini
        'On l'ajoute dans la liste
        If Not Exist(Ini) Then LoadMSF Ini, Path, Mid(Ini, 1, Len(Ini) - 4)

        '-- Recursivit de la Fonction SearchInDEP
        SearchInDEP GetWinSysDir & "\" & Mid(Word, 1, Len(Word) - 3) & "DEP", Word

    Loop Until Word = ""
End Function

'Juste, cette fonction permet de verifier qu'un fchier n'existe pas deja dans la liste
'afin d'eviter les doublons
Private Function Exist(ByVal sFile As String) As Boolean
Dim i As Integer

    Exist = False
    For i = 0 To ShowDep.ShowDepFile.Rows - 1
        If LCase(sFile) = LCase(ShowDep.ShowDepFile.TextMatrix(i, 0)) Or sFile = "" Then
            Exist = True
            Exit For
        End If
    Next
End Function

'Cette procedure permet de charger un fichier dans la liste des fichier de dependance
Public Sub LoadMSF(sFile As String, sPath As String, Optional sName As String, Optional ByVal Reg As String)
Dim VBRT
Dim strIS As String
Dim i As Integer

    VBRT = Array("asycfilt.dll", "comcat.dll", "msvbvm60.dll", "oleaut32.dll", "olepro32.dll", "stdole2.tlb")
    With ShowDep
        '-- Filtrer les fichiers du Runtime VB6
        If .chkRTFiles <> 0 Then
            For i = 0 To UBound(VBRT)
                If LCase(sFile) = VBRT(i) Then Exit Sub
            Next
        End If

        .ShowDepFile.TextMatrix(ShowDep.ShowDepFile.Rows - 1, 0) = sFile

        ReDim Preserve NameTab(.ShowDepFile.Rows - 1)

        If sName = "" Then
            NameTab(.ShowDepFile.Rows - 1) = Mid(sFile, 1, Len(sFile) - 4)
        Else
            NameTab(.ShowDepFile.Rows - 1) = sName
        End If

        .ShowDepFile.TextMatrix(ShowDep.ShowDepFile.Rows - 1, 1) = Trim(sPath)
        .ShowDepFile.AddItem ""

        If .chkIS <> 0 Then
            '-- Construction de la chaine au Format Inno Setup
            '-- Source
            If LCase(ExtractFilePath(sPath, False)) = LCase(GetWinSysDir) Then
                If .chkSysDir = 0 Then
                    strIS = "Source: " & ExtractFileName(Trim(sPath)) & ";"
                Else
                    strIS = "Source: " & Trim(sPath) & ";"
                End If
            ElseIf LCase(ExtractFilePath(sPath)) = AppDir Then
                If .chkAppDir = 0 Then
                    strIS = "Source: " & ExtractFileName(Trim(sPath)) & ";"
                Else
                    strIS = "Source: " & Trim(sPath) & ";"
                End If
            Else
                strIS = "Source: " & Trim(sPath) & ";"
            End If

            '-- Destdir
            strIS = strIS & " Destdir: {sys};"
            '-- Flags
            For i = 0 To .chkFlagdIS.Count - 1
                If .chkFlagdIS(i).Value <> 0 Then
                    strIS = strIS & " Flags:"
                    Exit For
                End If
            Next
            If .chkFlagdIS(0) Then strIS = strIS & " promptifolder"
            If .chkFlagdIS(1) Then strIS = strIS & " sharedfile"
            If .chkFlagdIS(2) Then strIS = strIS & " allowunsafefiles"
            If .chkFlagdIS(3) And (Reg <> "" Or LCase(ExtractFileExt(sPath)) = "tlb") Then
                Select Case LCase(ExtractFileExt(sPath))
                Case "dll", "ocx"
                    strIS = strIS & " regserver"
                Case "tlb"
                    strIS = strIS & " regtypelib"
                End Select
            End If
            .Text1.Text = .Text1.Text & strIS & vbCrLf
        Else
            .Text1.Text = .Text1.Text & Trim(sPath) & vbCrLf
        End If
    End With
End Sub

